/* sorgente: SetOfStrings.c */

/* Codice che implementa il tipo di dato astratto
** insieme di stringhe */

/* inclusione del file di intestazione della libreria standard che
** contiene definizioni di macro, costanti e dichiarazioni di funzioni
** e tipi di interesse generale e funzionali alle varie operazioni di I/O */
#include <stdio.h>
#include <stdlib.h>

/*
** funzione per la definizione di un nuovo insieme di stringhe
*/
char **newSetOfStrings (unsigned int dimOfSet)
	{
	/* cursore per la scansione del vettore di accesso alle stringhe */
	int cursore;
	
	/* definizione della variabile per l'accesso all'insieme*/
	char **pointOfAccess;
	
	/* definisco il vettore di accesso alle stringhe dell'insieme */
	pointOfAccess = (char **) malloc (dimOfSet * sizeof(char *));
	
	/* verifico se l'allocazione e' andata a buon fine */
	if (pointOfAccess == NULL)
	 return(NULL);
 
	/* inizializzo a NULL tutti gli elementi del vettore */
	for (cursore =0; cursore < dimOfSet; cursore++)
		 pointOfAccess[cursore] = NULL;
	
	return(pointOfAccess);
	}

/*
** funzione per la visualizzazione del contenuto dell'insieme di stringhe
*/
void visSetOfStrings (char ** setOfStrings, unsigned int dimOfSet)
	{
	/* cursore per la scansione del vettore di accesso alle stringhe */
	int cursore;
 
	/* scandisco il vettore e visualizzo le stringhe nell'insieme,
	** se presenti */
	for (cursore =0; cursore < dimOfSet; cursore++)
		if (setOfStrings[cursore] != NULL)
	      printf ("\nStringa %d: %s", cursore, setOfStrings[cursore]);
		else
		  printf ("\nStringa %d: non specificata", cursore);
	}	

/*
** funzione per l'inserimento di una nuova stringa nell'insieme
*/
int insSetofStrings(char ** setOfStrings, unsigned int dimOfSet, char * str)
  {
  /* cursore per la scansione del vettore di accesso alle stringhe */
  int cursore = 0;
  
  printf("\n");

  /* verifica se esiste una posizione disponibile all'interno del vettore
  ** di accesso alle stringhe */
  while ((setOfStrings[cursore] != NULL) && (cursore < dimOfSet))
	  cursore++;
  
  /* in caso di risposta negativa, termina con insuccesso */
  if (cursore == dimOfSet)
	return(0);

  /* altrimenti, inserisce la stringa nell'insieme e termina con successo */
  setOfStrings[cursore] = str;
  
  return(1);
  }


/* chiamante */
int main ()
  {
  /* variabile che contiene l'esito delle operazioni effettuate sull'insieme */
  int testOp;
  
  /* definizione della variabile per la dimensione massima dell'insieme */
  unsigned int dimOfSet;
  
  /* definizione della variabile per la dimensione massima della stringa */
  unsigned int dimOfStr;
  
  /* variabile per il nome dell'insieme di stringhe */
  char **testSet;
  
  /* definizione delle stringhe di test */
  char * testStr1;
  char * testStr2;
  
  /* acquisisco la dimensione massima delle stringhe */
  printf("\nDimensione massima delle stringhe? ");
  scanf("%u", &dimOfStr);
  
  /* accquisizione della dimensione massima dell'insieme */
  printf("\nDimensione massima dell'insieme? ");
  scanf("%u", &dimOfSet);
  
  /* alloco memoria per le stringhe di test */
  testStr1 = (char *) malloc(dimOfStr * sizeof(char));
  testStr2 = (char *) malloc(dimOfStr * sizeof(char));
  
  /* dovrei testare l'esito dell'allocazione */
  
  /* definisco un nuovo insieme di stringhe */
  testSet = newSetOfStrings (dimOfSet);
  
  /* testo l'esito della definizione */
  if (testSet == NULL)
    {
	printf("\nDefinizione dell'insieme fallita!!!");
    return(0);
    };
	
  printf("\nDefinizione dell'insieme a buon fine!!!");

  /* acquisiszione della prima stringa di test */
  printf("\nPrima stringa da inserire? ");
  scanf("%s", testStr1);
  
  /* acquisiszione della stringa di test */
  printf("\nSeconda stringa da inserire? ");
  scanf("%s", testStr2);
  
  /* inserisco la prima stringa acquisita nell'insieme */
  testOp = insSetofStrings(testSet, dimOfSet, testStr1);
  
  /* testo l'esito dell'operazione di inserimento */
  if (testOp)
	  printf("\n\nOperazione di inserimento a buon fine");
  else
	  printf("\n\nOperazione di inserimento con esito negativo");
  
  /* visualizzo il contenuto dell'insieme */
  visSetOfStrings (testSet, dimOfSet);
  
  /* inserisco la seconda stringa acquisita nell'insieme */
  testOp = insSetofStrings(testSet, dimOfSet, testStr2);
  
  /* testo l'esito dell'operazione di inserimento */
  if (testOp)
	  printf("\n\nOperazione di inserimento a buon fine");
  else
	  printf("\n\nOperazione di inserimento con esito negativo");
  
  /* visualizzo il contenuto dell'insieme */
  visSetOfStrings (testSet, dimOfSet);
  
  /* recupero la memoria allocata all'insieme */
  
  return(1);
  }
